    PROGRAM nag_mat_inv_ex07

      ! Example Program Text for nag_mat_inv
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_mat_inv, ONLY : nag_gen_mat_inv_fac
      USE nag_gen_lin_sys, ONLY : nag_gen_lin_fac
      USE nag_examples_io, ONLY : nag_std_out, nag_std_in
      USE nag_write_mat, ONLY : nag_write_gen_mat
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, n
      ! .. Local Arrays ..
      INTEGER, ALLOCATABLE :: pivot(:)
      REAL (wp), ALLOCATABLE :: a(:,:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_mat_inv_ex07'
      WRITE (nag_std_out,*)

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) n

      ALLOCATE (a(n,n),pivot(n))   ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,n)

      CALL nag_gen_lin_fac(a,pivot)

      CALL nag_write_gen_mat(a,title='Factorized matrix')

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) 'Pivotal sequence (pivot)'
      WRITE (nag_std_out,'(2X,10I4:)') pivot

      CALL nag_gen_mat_inv_fac(a,pivot)

      WRITE (nag_std_out,*)

      CALL nag_write_gen_mat(a,format='F10.4',title= &
       'The inverse - using the factorized matrix')

      DEALLOCATE (a,pivot)         ! Deallocate storage

    END PROGRAM nag_mat_inv_ex07
